' ------------------------------------------------------------------------------------------------------------
'| This source code is provided 'as is' and any express or implied warranties, including,                     |
'| but not limited to, the implied warranties of merchantability and fitness for a particular                 |
'| purpose are disclaimed.                                                                                    |
'|                                                                                                            |
'| In no event shall the author, Crownhill or contributers be liable for any direct, indirect, incidental,    |
'| special, exemplary, or consequential damages (including, but not limited to,  procurement of substitute    |
'| goods or services; loss of use, data, or profits;  or business interruption) however caused and on any     |
'| theory of liability, whether in contract, strict liability, or tort (including negligence or otherwise)    |
'| arising in any way out of the use of this source code, even if advised of the possibility of such damage.  |
'|                                                                                                            |
'| Any views and conclusions contained in the source code and any documentation are those of the author's     |
'| and should not be interpreted as representing official policies,                                           |
'| either expressed or implied, of Crownhill Associates Ltd.                                                  |
' ------------------------------------------------------------------------------------------------------------
'
' Demonstrate RAM and code memory string array handling
'
    Include "Amicus18.inc"                          ' Configure the compiler for a PIC18F25K20 operating at 64MHz
    Include "String Array.inc"                      ' Load the string array macros into the program

    Dim bIndex As Byte                              ' Temporary byte used for demo
    Dim TempString As String * 32                   ' Temporary string used by demo

    Create_StringArray(MyString, 10, 24)            ' Create a 10 string RAM array, with each string 24 characters in length

    Create_CodeStringArray(MyCodeString, 10, 24)    ' Declare a 10 string code memory array, with each String 24 characters in length
'
' Create the data for the code memory string array
' The code memory string must be an even amount of bytes (including the null)
'
    Dim MyCodeString As Code = "My Code String Array 0", 0, 0,_
                               "My Code String Array 1", 0, 0,_
                               "My Code String Array 2", 0, 0,_
                               "My Code String Array 3", 0, 0,_
                               "My Code String Array 4", 0, 0,_
                               "My Code String Array 5", 0, 0,_
                               "My Code String Array 6", 0, 0,_
                               "My Code String Array 7", 0, 0,_
                               "My Code String Array 8", 0, 0,_
                               "My Code String Array 9", 0, 0

'--------------------------------------------------------------------------------------
' Test the string array macros by loading then retrieving values
'
Main:
    Clear                                                           ' Clear all RAM before we start
'
' Write and read a RAM string array
'
    For bIndex = 0 To 7
        TempString = "MyString RAM Array " + Str$(Dec bIndex)       ' Fill the string to load and retrieve
        Write_StringArray MyString, [bIndex], TempString            ' Load the RAM string array
        TempString = Read_StringArray MyString, [bIndex]            ' Retreive the RAM string array
        HRSOut TempString, 13                                       ' Display the results serially
    Next
'
' Read from a code memory string array
'
    For bIndex = 0 To 7
        TempString = Read_CodeStringArray MyCodeString, [bIndex]    ' Retrieve a code memory string array
        HRSOut TempString, 13                                       ' Display the results serially
    Next
    Stop



